package com.sample;


import org.junit.Test;
import org.kie.api.KieBase;
import org.kie.api.KieServices;
import org.kie.api.builder.ReleaseId;
import org.kie.api.runtime.KieContainer;
import org.kie.api.runtime.KieSession;

/**
 * This is a sample class to launch a rule.
 */
public class DroolsTest {

    @Test
    public void testDeepClone() {
        try {
            
            KieServices ks = KieServices.Factory.get();
            
            ReleaseId releaseId = ks.newReleaseId("com.sample", "drools-mvn-kjar", "1.0.0-SNAPSHOT");
            
            KieContainer kContainer1 = ks.newKieContainer(releaseId);
            
            KieBase kieBase1 = kContainer1.getKieBase();
            
            System.out.println(releaseId);
            
            KieContainer kContainer2 = ks.newKieContainer(releaseId);
            
            KieBase kieBase2 = kContainer2.getKieBase();
            
            System.out.println(kieBase1);
            System.out.println(kieBase2);
            
            KieSession kSession = kContainer1.newKieSession();

            // go !
            InvoiceLine invoiceLine = new InvoiceLine();

            invoiceLine.setProcedureType("Test2");
            invoiceLine.setProcedureCode("1111-1111-0001");
            
            System.out.println(invoiceLine.getStatus());

            kSession.insert(invoiceLine);

            kSession.fireAllRules();
            
            System.out.println(invoiceLine.getStatus());

        } catch (Throwable t) {
            t.printStackTrace();
        }
    }
}
